package modelo;
// Generated 15 dic 2022 16:34:03 by Hibernate Tools 4.3.6.Final

import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.FetchType;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.OneToMany;
import jakarta.persistence.Table;
import jakarta.persistence.Temporal;
import jakarta.persistence.TemporalType;

/**
 * Factura generated by hbm2java
 */
@Entity
@Table(name = "factura", catalog = "emphb")
public class Factura implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer id;
	private Cliente cliente;
	private Vendedor vendedor;
	private Date fecha;
	private String formapago;
	private Set<Linfactura> linfacturas = new HashSet<Linfactura>(0);

	public Factura() {
	}

	public Factura(Cliente cliente, Vendedor vendedor) {
		this.cliente = cliente;
		this.vendedor = vendedor;
	}

	public Factura(Cliente cliente, Vendedor vendedor, Date fecha, String formapago, Set<Linfactura> linfacturas) {
		this.cliente = cliente;
		this.vendedor = vendedor;
		this.fecha = fecha;
		this.formapago = formapago;
		this.linfacturas = linfacturas;
	}

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "id", unique = true, nullable = false)
	public Integer getId() {
		return this.id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "cliente", nullable = false)
	public Cliente getCliente() {
		return this.cliente;
	}

	public void setCliente(Cliente cliente) {
		this.cliente = cliente;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "vendedor", nullable = false)
	public Vendedor getVendedor() {
		return this.vendedor;
	}

	public void setVendedor(Vendedor vendedor) {
		this.vendedor = vendedor;
	}

	@Temporal(TemporalType.DATE)
	@Column(name = "fecha", length = 10)
	public Date getFecha() {
		return this.fecha;
	}

	public void setFecha(Date fecha) {
		this.fecha = fecha;
	}

	@Column(name = "formapago", length = 20)
	public String getFormapago() {
		return this.formapago;
	}

	public void setFormapago(String formapago) {
		this.formapago = formapago;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "factura")
	public Set<Linfactura> getLinfacturas() {
		return this.linfacturas;
	}

	public void setLinfacturas(Set<Linfactura> linfacturas) {
		this.linfacturas = linfacturas;
	}

	@Override
	public String toString() {
		return "Factura [id=" + id + ", cliente=" + cliente + ", vendedor=" + vendedor + ", fecha=" + fecha
				+ ", formapago=" + formapago + ", total lineas: " + linfacturas.size() + "]";
	}
	
}
